if (typeof String.prototype.startsWith != 'function') {
    String.prototype.startsWith = function(prefix) {
        return this.slice(0, prefix.length) === prefix;
    };
}
/*添加命名空间,避免和页面中其他脚本产生命名冲突*/
if (typeof _h5FullScreenJs == 'undefined') {
    _h5FullScreenJs = {};

    _h5FullScreenJs.deviation = 0.95;

    _h5FullScreenJs.videoTag = null;

    _h5FullScreenJs.videoIframe = null;

    _h5FullScreenJs.isFullScreen = false;

    _h5FullScreenJs.mediaEvents = null;

    _h5FullScreenJs.zoomRatioByJava = 1;

    _h5FullScreenJs.waitElementSizeChangedTimes = 3;

    /*部分站点在部分UA下使用style.zoom不生效,因此需要采用java中的webview来实现缩放*/
    _h5FullScreenJs.isZoomByJava = function() {
        var isZoomByJava = false;
        var host = location.host;
        if (host.indexOf(".le.") > 0 ||
            host.indexOf(".qq.") > 0 ||
            host.indexOf(".mgtv.") > 0) {
            /*these sites with ipad UA must zoom by java*/
            isZoomByJava = true;
        }
        return isZoomByJava;
    };

    /*部分站点必须主动调用播放,比如pptv,优酷...,其他站点可以设置video事件监听等待页面自身js来触发*/
    _h5FullScreenJs.isPlayManuallySite = function() {
        var host = location.host;
        if (host.indexOf(".youku.") > 0 ||
            host.indexOf(".pptv.") > 0 ||
            host.indexOf(".1905.") > 0 ||
            host.indexOf(".qq.") > 0 ||
            host.indexOf(".le.") > 0 ||
            host.indexOf(".mgtv.") > 0) {
            return true;
        }
        return false;
    };

    _h5FullScreenJs.playBtn = null;
    /*部分站点采用video.play不生效,甚至只有点击播放按钮后才会给video标签设置src或者为video标签设置宽高,此时必须获取播放相关按钮*/
    _h5FullScreenJs.getPlayBtn = function() {
        var host = location.host;
        var ua = navigator.userAgent;

        if (host.indexOf(".iqiyi.") > 0) {
            /*_h5FullScreenJs.playBtn = document.getElementsByClassName('c-videoplay')[0];*/
        } else if (host.indexOf(".tudou.") > 0) {
            _h5FullScreenJs.playBtn = document.getElementsByClassName('td-h5__player__button__play-ico')[0];
        } else if (host.indexOf(".youku.") > 0) {
            _h5FullScreenJs.playBtn = document.getElementsByClassName('x-video-play-ico')[0];
        } else if (host.indexOf(".qq.") > 0) {
            if (ua.indexOf("iPad") > 0) {
                _h5FullScreenJs.playBtn = document.getElementsByClassName('tvp_open_btn_b')[0];
            } else {
                _h5FullScreenJs.playBtn = document.getElementsByClassName('txp_btn_play_lg')[0];
            }
        } else if (host.indexOf(".sohu.") > 0) {
            _h5FullScreenJs.playBtn = document.getElementsByClassName('x-bigplaybtn-panel')[0];
        } else if (host.indexOf(".fun.") > 0) {
            _h5FullScreenJs.playBtn = document.getElementsByClassName('play-btn')[0];
        } else if (host.indexOf(".1905.") > 0) {
            _h5FullScreenJs.playBtn = document.getElementById('playerbtn');
        } else if (host.indexOf(".pptv.") > 0) {
            if (_h5FullScreenJs.videoIframe) {
                _h5FullScreenJs.playBtn = _h5FullScreenJs.videoIframe.contentDocument.getElementsByClassName('p-video-button')[0];
            }
        } else if (host.indexOf(".mgtv.") > 0) {
            if (ua.indexOf("iPhone") > 0 || ua.indexOf("iPad") > 0) {
                _h5FullScreenJs.playBtn = document.getElementById('playBtn');
            }
        } else if (host.indexOf(".le.") > 0) {
            _h5FullScreenJs.playBtn = document.getElementsByClassName('hv_ico_pasued')[0];
        }
        return _h5FullScreenJs.playBtn != null;
    };

    _h5FullScreenJs.selectDefinition = function() {
        var definitionBtn = null;
        var host = location.host;
        var isLowEndDevice = (_h5FullScreenJs.deviceSdkInt > 0 && _h5FullScreenJs.deviceSdkInt < 19);
        if (host.indexOf('.iqiyi.') > 0) {
            var definitionType = isLowEndDevice ? "流畅" : " 高清";
            var definitionBtns = document.getElementsByClassName('c-videoType-item');
            for (var i = 0; i < definitionBtns.length; i++) {
                var btn = definitionBtns[i];
                if (btn.innerText == definitionType) {
                    definitionBtn = btn;
                    break;
                }
            }
        } else if (host.indexOf(".sohu.") > 0) {
            /*搜狐站点有时必须点击高清按钮,否则不设置video src导致不能播放*/
            var resolutions = document.getElementsByClassName('x-resolution-panel')[0];
            var definitionIndex = isLowEndDevice ? 0 : 1;
            if (resolutions && resolutions.childElementCount > definitionIndex) {
                definitionBtn = resolutions.children[definitionIndex];
            }
        }
        fullscreenCtrl.info("selectDefinition, isLowEndDevice:" + isLowEndDevice + ",definitionBtn:" + _h5FullScreenJs.elementToString(definitionBtn));
        if (!definitionBtn) {
            return false;
        }
        _h5FullScreenJs.click(definitionBtn);
        return true;
    };

    /*进入浏览器自带全屏模式,最保险的方式是点击全屏按钮,比如爱奇艺站点,只有点击全屏按钮时才会触发它的js进行
    全屏状态下播放控制栏的露出,因此爱奇艺站点不点击全屏按钮进入全屏后不显示控制栏*/
    _h5FullScreenJs.isFullScreenBtnClicked = false;
    _h5FullScreenJs.clickFullScreenBtn = function(enter) {
        var fullScreenBtn = null;
        var host = location.host;

        /* 分站点找全屏按钮 */
        if (host.indexOf(".iqiyi.") > 0) {
            fullScreenBtn = document.getElementsByClassName('fullScreen')[0];
        } else if (host.indexOf(".sohu.") > 0) {
            fullScreenBtn = document.getElementsByClassName('x-fs-btn')[0];
        }

        if (fullScreenBtn) {
            if ((enter && !_h5FullScreenJs.isFullScreenBtnClicked) ||
                (!enter && _h5FullScreenJs.isFullScreenBtnClicked)){
                fullscreenCtrl.info("clickFullScreenBtn, enter:" + enter + ",btn:" + _h5FullScreenJs.elementToString(fullScreenBtn));
                _h5FullScreenJs.click(fullScreenBtn);
                _h5FullScreenJs.isFullScreenBtnClicked = !_h5FullScreenJs.isFullScreenBtnClicked;
            }
        } else {
            fullscreenCtrl.info("clickFullScreenBtn, enter:" + enter + " by webkitXXXFullScreen api");
            if (enter) {
                _h5FullScreenJs.videoTag.webkitRequestFullScreen();
            } else {
                _h5FullScreenJs.videoTag.webkitExitFullScreen();
            }
        }
    };

    _h5FullScreenJs.elementsHideDelay = 0;
    _h5FullScreenJs.topElements2Hide = [];
    _h5FullScreenJs.bottomElements2Hide = [];
    /*部分站点在video标签的上下侧悬浮其他页面元素,挡住部分画面,因此需要自动隐藏并随着用户滑动事件恢复展示*/
    _h5FullScreenJs.getElements2Hide = function() {
        var host = location.host;
        _h5FullScreenJs.elementsHideDelay = 0;
        _h5FullScreenJs.addElements(_h5FullScreenJs.topElements2Hide, document.getElementsByTagName('header')[0]);
        if (host.indexOf('.mgtv.') > 0) {
            _h5FullScreenJs.elementsHideDelay = 0;
            _h5FullScreenJs.addElements(_h5FullScreenJs.topElements2Hide, document.getElementsByClassName('m-headerbar')[0]);
            _h5FullScreenJs.addElements(_h5FullScreenJs.bottomElements2Hide, document.getElementsByClassName('mg-app-open')[0]);
        } else if (host.indexOf(".iqiyi.") > 0) {
            /*iqiyi采用ipad的UA时,视频右侧栏隐藏*/
            _h5FullScreenJs.addElements(_h5FullScreenJs.topElements2Hide, document.getElementById('block-D1'));

            var bottomNativePopup = document.getElementById('bottomNativePopup');
            bottomNativePopup.setAttribute('recover_style_display', 'inline');
            _h5FullScreenJs.addElements(_h5FullScreenJs.bottomElements2Hide, bottomNativePopup);
        } else if (host.indexOf(".qq.") > 0) {
            _h5FullScreenJs.addElements(_h5FullScreenJs.topElements2Hide, document.getElementById('top_followSeries'));
            /*ipad UA*/
            _h5FullScreenJs.addElements(_h5FullScreenJs.topElements2Hide, document.getElementById('new_vs_header'));
            /*ipad UA*/
            _h5FullScreenJs.addElements(_h5FullScreenJs.topElements2Hide, document.getElementsByClassName('site_head_drawer')[0]);
            /*ipad UA*/
        } else if (host.indexOf(".youku.") > 0) {
            _h5FullScreenJs.elementsHideDelay = 5000;
            var divs = document.getElementsByTagName('div');
            for (var i = 0; i < divs.length; i++) {
                if (divs[i].getAttribute('data-stat-role')) {
                    _h5FullScreenJs.addElements(_h5FullScreenJs.topElements2Hide, divs[i]);
                    break;
                }
            }
        } else if (host.indexOf(".tudou.") > 0) {
            var divs = document.getElementsByTagName('div');
            for (var i = 0; i < divs.length; i++) {
                if (divs[i].getAttribute('data-js') == 'td-appguide') {
                    _h5FullScreenJs.addElements(_h5FullScreenJs.bottomElements2Hide, divs[i]);
                    break;
                }
            }
        } else if (host.indexOf(".1905.") > 0) {
            _h5FullScreenJs.addElements(_h5FullScreenJs.topElements2Hide, document.getElementById('app_store'));

            /*按照产品要求,不能隐藏广告图片即便是它盖住了视频*/
            /*var iframes = document.getElementsByTagName('iframe');
             for (var i=0;i<iframes.length;i++) {
             var p = iframes[i].parentElement;
             if (p && p.style && p.style.position == 'fixed') {
             _h5FullScreenJs.addElements(_h5FullScreenJs.bottomElements2Hide, p);
             }
             }*/
        } else if (host.indexOf(".le.") > 0) {
            if (navigator.userAgent.indexOf("iPhone") > 0) {
                /* iPhone的ua下,乐视站点的视频莫名其妙的有一个全屏的遮罩和一个播放按钮浮在video上层,小屏也有,所以不能恢复显示 */
                _h5FullScreenJs.elementsHideDelay = -1;
                _h5FullScreenJs.addElements(_h5FullScreenJs.bottomElements2Hide, document.getElementsByClassName('hv_play_poster')[0]);
                _h5FullScreenJs.addElements(_h5FullScreenJs.bottomElements2Hide, document.getElementsByClassName('hv_ico_pasued')[0]);
            }
        }
    };

    /*webview提供的缩放方法中zoomIn不支持设置比例,因此无法让video标签精确全屏,zoomBy有系统版本限制,因此需要处理缩放失败的情况*/
    _h5FullScreenJs.timeoutZoomInByJava = 0;
    _h5FullScreenJs.onZoomInByJavaResult = function(succeed) {
        fullscreenCtrl.info("onZoomInByJavaResult, succeed:" + succeed);
        if (succeed) {
            var cmd = "scrollToVideo()";
            fullscreenCtrl.callJsVideoCmd(cmd, true);
            var delay = _h5FullScreenJs.delayAdaptDevice;
            clearTimeout(_h5FullScreenJs.timeoutZoomInByJava);
            _h5FullScreenJs.timeoutZoomInByJava = _h5FullScreenJs.setTimeoutByJava(cmd, delay(2000));
        } else {
            var host = location.host;
            if (host.indexOf(".le.") > 0) {
                var albumList = document.getElementsByClassName('le_jujiCnt')[0];
                var hideAlbumListBtn = document.getElementsByClassName('ico_fold')[0];
                if (!albumList || !hideAlbumListBtn) {
                    return;
                }
                var isAlbumListVisible = albumList.getBoundingClientRect().left < document.body.clientWidth;
                if (isAlbumListVisible) {
                    _h5FullScreenJs.click(hideAlbumListBtn);
                    fullscreenCtrl.error("onZoomInByJavaResult, hideAlbumListBtn");
                }
            }
        }
    };

    /*js setTimeout中调用的video函数会报错:必须由用户触摸事件触发,因此必须重新转给java层执行*/
    _h5FullScreenJs.setTimeoutByJava = function(cmd, delay) {
        fullscreenCtrl.info("setTimeoutByJava, cmd:" + cmd + ",delay:" + delay);
        var timeoutCmd = 'fullscreenCtrl.callJsVideoCmd("' + cmd + '", true)';
        return setTimeout(timeoutCmd, delay);
    };

    _h5FullScreenJs.setTimeoutByJs = function(cmd, delay) {
        var timeoutCmd = '_h5FullScreenJs.' + cmd;
        return setTimeout(timeoutCmd, delay);
    };

    /*通过js的scroll调整video标签的位置,让video的左上角与屏幕左上角对齐*/
    _h5FullScreenJs.scrollToVideo = function() {
        var rect = _h5FullScreenJs.getVideoPos();
        if (rect.width <= 0 || rect.height <= 0) {
            fullscreenCtrl.info("scrollToVideo, videoTag size is 0");
            return;
        }

        var vtop = 0;
        var topMargin = 0;
        if (_h5FullScreenJs.videoIframe) {
            /* pptv */
            vtop = rect.top;
            var iframeRect = _h5FullScreenJs.videoIframe.getBoundingClientRect();
            if (rect.height > iframeRect.height) {
                topMargin = (rect.height - iframeRect.height) / 2;
            }
        } else {
            var bodyRect = document.body.getBoundingClientRect();
            vtop = rect.top - bodyRect.top;
            topMargin = (rect.height - rect.width * 9 / 16) / 2;
        }
        vtop = vtop + topMargin;

        document.addEventListener('scroll', _h5FullScreenJs.onDocumentScroll);
        document.body.scrollLeft = rect.left;
        /*document.body.scrollTop = rect.top * document.body.style.zoom;*/
        document.body.scrollTop = vtop;
        fullscreenCtrl.info("scrollToVideo left:" + rect.left + ",top:" + vtop);
    };

    _h5FullScreenJs.isPlayBtnClicked = false;
    /*播放方法*/
    _h5FullScreenJs.play = function() {
        fullscreenCtrl.info("play");
        if (!_h5FullScreenJs.videoTag) {
            fullscreenCtrl.error("play videoTag is null");
            return false;
        }
        if (_h5FullScreenJs.videoTag.currentTime > 0 && !_h5FullScreenJs.videoTag.paused) {
            fullscreenCtrl.info("play videoTag is already playing");
            return true;
        }
        /*播放按钮绝对不能多次点击,因为会导致播放和暂停状态来回切换*/
        if (!_h5FullScreenJs.isPlayBtnClicked && _h5FullScreenJs.getPlayBtn()) {
            var playBtn = _h5FullScreenJs.playBtn;
            fullscreenCtrl.info("play click playBtn:" + _h5FullScreenJs.elementToString(playBtn));
            _h5FullScreenJs.click(playBtn);
            _h5FullScreenJs.isPlayBtnClicked = true;
            return true;
        }
        if (_h5FullScreenJs.videoTag.src == '') {
            fullscreenCtrl.info("play videoTag.src is not set");
            return false;
        }
        try {
            _h5FullScreenJs.videoTag.play();
            fullscreenCtrl.info("play videoTag.play succeed");
        } catch(e) {
            fullscreenCtrl.error("play videoTag.play failed");
            return false;
        }
        return true;
    };

    _h5FullScreenJs.formatVideoTime = function(videoTime) {
        /* typeof NaN也是number,所以需要单独判断*/
        if (isNaN(videoTime)) {
            return 0;
        }
        if (videoTime == Infinity) {
            return 0;
        }
        if (typeof videoTime != "number") {
            return 0;
        }
        var floatVal = parseFloat(videoTime);
        if (floatVal < 0) {
            return 0;
        }
        return parseInt(floatVal * 1000);
    };

    /* 根据duration判断是否广告分段,单位:毫秒*/
    _h5FullScreenJs.isAd = function(duration) {
        var sec = parseInt(duration / 1000);
        if (duration - sec * 1000 > 500) {
            sec++;
        }
        if (sec > 0 && sec % 5 == 0 && sec <= 60) {
            return 1;
        }
        return 0;
    };

    _h5FullScreenJs.getDuration = function() {
        var ret_duration = 0;
        var ret_isAd = 0;
        do {
            if (!_h5FullScreenJs.videoTag) {
                fullscreenCtrl.error("getDuration videoTag is null");
                break;
            }
            var duration = _h5FullScreenJs.formatVideoTime(_h5FullScreenJs.videoTag.duration);
            ret_duration = duration;
            ret_isAd = _h5FullScreenJs.isAd(duration);
        } while(0);
        var retVal = ret_duration + "," + ret_isAd;
        fullscreenCtrl.info("getDuration:" + retVal);
        return retVal;
    };

    _h5FullScreenJs.getCurrentPosition = function() {
        if (!_h5FullScreenJs.videoTag) {
            fullscreenCtrl.error("getDuration videoTag is null");
            return 0;
        }
        return _h5FullScreenJs.formatVideoTime(_h5FullScreenJs.videoTag.currentTime);
    };

    /*暂停方法*/
    _h5FullScreenJs.pause = function() {
        fullscreenCtrl.info("pause");
        if (!_h5FullScreenJs.videoTag) {
            fullscreenCtrl.error("pause videoTag is null");
            return;
        }
        if (_h5FullScreenJs.videoTag.paused) {
            fullscreenCtrl.info("pause videoTag is already paused");
            return;
        }
        try {
            _h5FullScreenJs.videoTag.pause();
            fullscreenCtrl.info("pause videoTag.pause succeed");
        } catch(e) {
            fullscreenCtrl.error("pause videoTag.pause failed");
        }
    };

    _h5FullScreenJs.dismissLoading = function() {
        fullscreenCtrl.onJsEvent(100, "dismissLoading", "");
    };

    _h5FullScreenJs.countPlayTry = function() {
        _h5FullScreenJs.dismissLoading();
        /* 播放尝试 */
        var jsonData = JSON.stringify({'title':document.title});
        fullscreenCtrl.onJsEvent(1, "Try", jsonData);
        fullscreenCtrl.setJsData("PlayTry","1");
    };

    _h5FullScreenJs.countPlaySuccess = function() {
        /* 播放成功 */
        var jsonData = JSON.stringify({'title':document.title});
        fullscreenCtrl.onJsEvent(2, "Success", jsonData);
        fullscreenCtrl.setJsData("PlayTry","0");
    };

     _h5FullScreenJs.countPlayAdSuccess = function() {
        /* 广告播放成功 */
        fullscreenCtrl.onJsEvent(3, "AdSuccess", "");
     };

    /*当页面发生变更时,清除“播放按钮已点击”标记*/
    _h5FullScreenJs.onPageChanged = function(url) {
        _h5FullScreenJs.zoomOut();
        _h5FullScreenJs.isPlayBtnClicked = false;
        _h5FullScreenJs.isFullScreenBtnClicked = false;
        _h5FullScreenJs.waitElementSizeChangedTimes = 3;
    };

    /*Seek方法*/
    _h5FullScreenJs.seek = function(pos) {
        fullscreenCtrl.info("seek:" + pos);
        if (!_h5FullScreenJs.videoTag) {
            fullscreenCtrl.error("seek videoTag is null");
            return;
        }
        _h5FullScreenJs.videoTag.currentTime = pos * 0.001;
    };

    _h5FullScreenJs.touchEvent = null;
    _h5FullScreenJs.click = function(element) {
        if (typeof element.click == "function") {
            element.click();
        } else {
            if (!_h5FullScreenJs.touchEvent) {
                _h5FullScreenJs.touchEvent = document.createEvent('Events');
                _h5FullScreenJs.touchEvent.initEvent('touchstart', true, true);
                _h5FullScreenJs.touchEvent.initEvent('touchend', true, true);
            }
            element.dispatchEvent(_h5FullScreenJs.touchEvent);
        }
    };

    /*初始化video标签支持的所有事件，并在每个事件触发时获取所关注的属性值*/
    _h5FullScreenJs.initEvents = function() {
        if (_h5FullScreenJs.mediaEvents != null) {
            return _h5FullScreenJs.mediaEvents;
        }
        _h5FullScreenJs.mediaEvents = {
            "abort": "",
            "canplay": "_h5FullScreenJs.videoTag.readyState",
            "canplaythrough": "",
            "durationchange": "_h5FullScreenJs.getDuration()",
            "emptied": "",
            "ended": "",
            "error": "_h5FullScreenJs.videoTag.networkState",
            "loadeddata": "",
            "loadedmetadata": "",
            "loadstart": "",
            "pause": "",
            "play": "_h5FullScreenJs.videoTag.currentSrc",
            "playing": "",
            "progress": "",
            "ratechange": "_h5FullScreenJs.videoTag.playbackRate",
            "readystatechange": "_h5FullScreenJs.videoTag.readyState",
            "seeked": "",
            "seeking": "",
            "stalled": "",
            "suspend": "",
            "timeupdate": "_h5FullScreenJs.getCurrentPosition()",
            "volumechange": "_h5FullScreenJs.videoTag.volume",
            "waiting": "",
        };
        for (var mediaEvent in _h5FullScreenJs.mediaEvents) {
            var param = _h5FullScreenJs.mediaEvents[mediaEvent];
            if (param == "") {
                param = "''";
            }
            var eventFunctionName = _h5FullScreenJs.formatEventListenerName(mediaEvent);
            var eventFunction = eventFunctionName + " = function() { fullscreenCtrl.onH5VideoEvent('" + mediaEvent + "'," + param + ");}";
            eval(eventFunction);
        }
        return _h5FullScreenJs.mediaEvents;
    };

    /*删除js事件监听器的前提是该事件的监听响应函数是命名的*/
    _h5FullScreenJs.formatEventListenerName = function(mediaEvent) {
        return "_h5FullScreenJs._on_" + mediaEvent;
    };

    /*添加video标签的事件监听*/
    _h5FullScreenJs.addEventListeners = function() {
        var mediaEvents = _h5FullScreenJs.initEvents();
        for (var mediaEvent in mediaEvents) {
            var eventFunctionName = _h5FullScreenJs.formatEventListenerName(mediaEvent);
            var addEvent = "_h5FullScreenJs.videoTag.addEventListener('" + mediaEvent + "', " + eventFunctionName + ");";
            eval(addEvent);
        }
    };

    /*移除video标签的事件监听*/
    _h5FullScreenJs.removeEventListeners = function() {
        var mediaEvents = _h5FullScreenJs.initEvents();
        for (var mediaEvent in mediaEvents) {
            var eventFunctionName = _h5FullScreenJs.formatEventListenerName(mediaEvent);
            var removeEvent = "_h5FullScreenJs.videoTag.removeEventListener('" + mediaEvent + "', " + eventFunctionName + ");";
            eval(removeEvent);
        }
    };

    /*将监听到的video事件转发给java层*/
    _h5FullScreenJs.sendVideoEvent = function(mediaEvent) {
        var data = null;
        var mediaEvents = _h5FullScreenJs.initEvents();
        var param = mediaEvents[mediaEvent];
        if (param == "") {
            data = param;
        } else {
            data = eval(param);
        }
        fullscreenCtrl.onH5VideoEvent(mediaEvent, data);
    };

    /*上报video当前的状态,用于进入自定义全屏模式时设置各个界面元素的初始值*/
    _h5FullScreenJs.reportCurrentStatus = function() {
        if (!_h5FullScreenJs.videoTag) {
            return;
        }
        fullscreenCtrl.info("reportCurrentStatus");
        if (typeof _h5FullScreenJs.videoTag.duration == "number") {
            _h5FullScreenJs.sendVideoEvent("timeupdate");
            _h5FullScreenJs.sendVideoEvent("durationchange");
        }
        if (_h5FullScreenJs.videoTag.paused) {
            _h5FullScreenJs.sendVideoEvent('pause');
        } else {
            _h5FullScreenJs.sendVideoEvent('play');
        }
    };

    /*java层在进入自定义全屏时通知js*/
    _h5FullScreenJs.onEnterFullScreen = function() {
        fullscreenCtrl.info("onEnterFullScreen");
        if (!_h5FullScreenJs.videoTag) {
            fullscreenCtrl.error("onEnterFullScreen videoTag is null");
            return;
        }
        _h5FullScreenJs.hideH5VideoControls(true);
        _h5FullScreenJs.reportCurrentStatus();
        _h5FullScreenJs.addEventListeners();
        _h5FullScreenJs.isFullScreen = true;
    };

    /*java层在退出自定义全屏时通知js*/
    _h5FullScreenJs.onExitFullScreen = function() {
        fullscreenCtrl.info("onExitFullScreen");
        if (!_h5FullScreenJs.videoTag) {
            fullscreenCtrl.error("onExitFullScreen videoTag is null");
            return;
        }
        _h5FullScreenJs.hideH5VideoControls(false);
        _h5FullScreenJs.removeEventListeners();
        _h5FullScreenJs.isFullScreen = false;
    };

    /*页面滚动时的响应函数*/
    _h5FullScreenJs.onDocumentScroll = function() {
        if (!_h5FullScreenJs.videoTag) {
            fullscreenCtrl.error("onDocumentScroll videoTag is null");
            return;
        }
        var rect = _h5FullScreenJs.getVideoPos();
        var vTop = rect.top;
        var vBottom = rect.bottom;
        fullscreenCtrl.info("onDocumentScroll,left:" + document.body.scrollLeft + ",top:" + document.body.scrollTop + ",videoTop:" + vTop + ",videoBottom:" + vBottom);
        if (vTop <= 0) {
            _h5FullScreenJs.hideTopElements(true);
            _h5FullScreenJs.hideBottomElements(false);
        } else {
            _h5FullScreenJs.hideTopElements(false);
            _h5FullScreenJs.hideBottomElements(true);
        }
    };

    /*获取video标签的位置和尺寸*/
    _h5FullScreenJs.getVideoPos = function() {
        if (!_h5FullScreenJs.videoTag) {
            fullscreenCtrl.error("getVideoPos videoTag is null");
            return {
                top: 0,
                left: 0,
                bottom: 0,
                right: 0,
                width: 0,
                height: 0
            };
        }
        var rect = _h5FullScreenJs.videoTag.getBoundingClientRect();
        fullscreenCtrl.info("getVideoPos rect, left:" + rect.left + ",top:" + rect.top + ",width:" + rect.width + ",height:" + rect.height + ",orientation:" + window.orientation);
        if (_h5FullScreenJs.videoIframe) {
            var iframeRect = _h5FullScreenJs.videoIframe.getBoundingClientRect();
            rect.top += iframeRect.top;
            rect.bottom += iframeRect.top;
            rect.left += iframeRect.left;
            rect.right += iframeRect.left;
        }
        return rect;
    };

    /*隐藏video标签默认的控制界面,此方法对于网页中定制的播放控制界面无效*/
    _h5FullScreenJs.hideH5VideoControls = function(isHide) {
        var head = document.head || document.getElementsByTagName('head')[0];
        if (!head) {
            fullscreenCtrl.error("head tag not found!!!");
            return;
        }
        var idH5HideOrigControls = '_h5HideOrigControls';
        if (isHide) {
            var style = document.createElement('style');
            style.id = idH5HideOrigControls;
            style.type = 'text/css';
            var textNode = document.createTextNode('video::-webkit-media-controls {opacity: 0;}');
            style.appendChild(textNode);
            head.appendChild(style);
        } else {
            var style = document.getElementById(idH5HideOrigControls);
            if (style) {
                head.removeChild(style);
            }
        }
    };

    /*将某个页面元素添加到动态数组中并避免重复*/
    _h5FullScreenJs.addElements = function(elements, element) {
        if (element && elements && elements.indexOf(element) < 0) {
            elements.push(element);
        }
    };

    /*打印页面元素的描述信息*/
    _h5FullScreenJs.elementToString = function(element) {
        if (!element) {
            return "null";
        }
        return "tagName:'" + element.tagName + "',id:'" + element.id + "',className:'" + element.className + "'";
    };

    _h5FullScreenJs.hideTopTimeout = 0;
    /*隐藏/显示 悬浮在video顶部的页面元素*/
    _h5FullScreenJs.hideTopElements = function(isHide) {
        clearTimeout(_h5FullScreenJs.hideTopTimeout);
        if (isHide) {
            if (_h5FullScreenJs.elementsHideDelay > 0) {
                _h5FullScreenJs.hideTopTimeout = _h5FullScreenJs.setTimeoutByJs('_hideH5Elements(true,true,false)', _h5FullScreenJs.elementsHideDelay);
                return true;
            }
        }
        return _h5FullScreenJs._hideH5Elements(isHide, true, false);
    };

    _h5FullScreenJs.hideBottomTimeout = 0;
    /*隐藏/显示 悬浮在video底部的页面元素*/
    _h5FullScreenJs.hideBottomElements = function(isHide) {
        clearTimeout(_h5FullScreenJs.hideBottomTimeout);
        if (isHide) {
            if (_h5FullScreenJs.elementsHideDelay > 0) {
                _h5FullScreenJs.hideBottomTimeout = _h5FullScreenJs.setTimeoutByJs('_hideH5Elements(true,false,true)', _h5FullScreenJs.elementsHideDelay);
                return true;
            }
        }
        return _h5FullScreenJs._hideH5Elements(isHide, false, true);
    };

    /*隐藏/显示 页面元素*/
    _h5FullScreenJs._hideH5Elements = function(isHide, doTop, doBottom) {
        var ret = false;
        if (isHide) {
            _h5FullScreenJs.getElements2Hide();
            if (doTop) {
                fullscreenCtrl.info("_hideH5Elements:" + isHide + " top");
                ret |= _h5FullScreenJs._doHide(_h5FullScreenJs.topElements2Hide, isHide);
            }
            if (doBottom) {
                fullscreenCtrl.info("_hideH5Elements:" + isHide + " bottom");
                ret |= _h5FullScreenJs._doHide(_h5FullScreenJs.bottomElements2Hide, isHide);
            }
        } else {
            if (doTop) {
                fullscreenCtrl.info("_hideH5Elements:" + isHide + " top");
                ret |= _h5FullScreenJs._doHide(_h5FullScreenJs.topElements2Hide, isHide);
            }
            if (doBottom) {
                fullscreenCtrl.info("_hideH5Elements:" + isHide + " bottom");
                ret |= _h5FullScreenJs._doHide(_h5FullScreenJs.bottomElements2Hide, isHide);
            }
        }
        return ret;
    };

    /*执行 隐藏/显示 的内部方法*/
    _h5FullScreenJs._doHide = function(elements, isHide) {
        if (!elements) {
            return false;
        }
        if (isHide) {
            for (var i = 0; i < elements.length; i++) {
                var element = elements[i];
                if (!element) {
                    continue;
                }
                if (!element.hidden) {
                    element.hidden = true;
                }
                if (element.style.display != "none") {
                    element.style.display = "none";
                }
            }
        } else {
            if (elements.length == 0) {
                return false;
            }
            for (var i = 0; i < elements.length; i++) {
                var element = elements[i];
                if (!element) {
                    continue;
                }
                if (element.hidden) {
                    element.hidden = false;
                }
                var recoverStyleDisplay = element.getAttribute('recover_style_display');
                if (recoverStyleDisplay) {
                    for (var j = 0; j < element.childElementCount; j++) {
                        var child = element.children[j];
                        if (!child) {
                            continue;
                        }
                        child.style.display = recoverStyleDisplay;
                    }
                    element.style.display = recoverStyleDisplay;
                } else if (element.style.display != "block") {
                    element.style.display = "block";
                }
            }
        }
        return true;
    };

    /*去除页面元素的 最小宽度,最小高度, 用于解决ipad ua下部分站点的网页过大导致超出屏幕的问题*/
    _h5FullScreenJs.noMinSize = function(element) {
        if (!element) {
            return;
        }
        var style = getComputedStyle(element, null);
        if (!style) {
            return;
        }
        var minWidth = parseInt(style.minWidth);
        if (minWidth > screen.width) {
            element.style.minWidth = screen.width + "px";
        }
        var minHeight = parseInt(style.minHeight);
        if (minHeight > screen.height) {
            element.style.minHeight = screen.height + "px";
        }
    };

    /*按比例放大页面,目的是让video标签的尺寸铺满屏幕*/
    _h5FullScreenJs.zoomIn = function(ratio) {
        if (ratio < 1 || ratio > 5) {
            return;
        }
        _h5FullScreenJs.zoomOut();
        if (_h5FullScreenJs.isZoomByJava()) {
            if (_h5FullScreenJs.zoomRatioByJava > 1) {
                fullscreenCtrl.info("already zoomIn by java, ratio" + ratio);
                _h5FullScreenJs.scrollToVideo();
            } else {
                if (fullscreenCtrl.zoom(ratio)) {
                    fullscreenCtrl.info("zoomIn by java, ratio:" + ratio);
                    _h5FullScreenJs.zoomRatioByJava = ratio;
                    /*java will call scrollToVideo*/
                } else {
                    _h5FullScreenJs.onZoomInByJavaResult(false);
                    _h5FullScreenJs.scrollToVideo();
                }
            }
        } else {
            if (document.body) {
                document.body.style.zoom = ratio;
                fullscreenCtrl.info("zoomIn by js, ratio:" + ratio);
                _h5FullScreenJs.scrollToVideo();
            }
        }
    };

    /*缩小页面，还原放大前的尺寸*/
    _h5FullScreenJs.zoomOut = function() {
        if (_h5FullScreenJs.isZoomByJava()) {
            if (_h5FullScreenJs.zoomRatioByJava > 1) {
                var ratio = 1 / _h5FullScreenJs.zoomRatioByJava;
                if (fullscreenCtrl.zoom(ratio)) {
                    fullscreenCtrl.info("zoomOut by java, ratio:" + ratio);
                    _h5FullScreenJs.zoomRatioByJava = 1;
                }
            }
        } else {
            if (document.body) {
                document.body.style.zoom = 1;
                fullscreenCtrl.info("zoomOut by js, ratio:1");
            }
        }
    };

    _h5FullScreenJs.isElementSizeStillUnchangedAfterOrientationChanged = function(videoRelatedElement) {
        /* 避免死循环*/
        if (_h5FullScreenJs.waitElementSizeChangedTimes > 0) {
            var screenWidth = screen.width;
            var screenHeight = screen.height;
            fullscreenCtrl.info("isElementSizeStillUnchangedAfterOrientationChanged videoRelatedElement:" + _h5FullScreenJs.elementToString(videoRelatedElement));
            var rect = videoRelatedElement.getBoundingClientRect();
            fullscreenCtrl.info("isElementSizeStillUnchangedAfterOrientationChanged videoRelatedElementSize:" + rect.width + " x " + rect.height + ",screenSize:" + screenWidth + " x " + screenHeight);
            /*横屏*/
            if (screenWidth >= screen.height) {
                /* 如果视频显示相关的页面元素还没横过来,那么很有可能该元素的宽度是竖屏的宽 */
                if (rect.width >= screen.height * _h5FullScreenJs.deviation && rect.width <= screen.height) {
                    _h5FullScreenJs.waitElementSizeChangedTimes -= 1;
                    fullscreenCtrl.error("isElementSizeStillUnchangedAfterOrientationChanged videoRelatedElement's size is still in portrait mode when screen is in landscape mode");
                    return true;
                }
            } else {
                /* 如果视频显示相关的页面元素还没竖过来,那么很有可能该元素的宽是横屏的宽,因此会超过当前竖屏状态下屏幕的宽*/
                if (rect.width > screen.width && rect.width <= screen.height) {
                    _h5FullScreenJs.waitElementSizeChangedTimes -= 1;
                    fullscreenCtrl.error("isElementSizeStillUnchangedAfterOrientationChanged videoRelatedElement's size is still in landscape mode when screen is in portrait mode");
                    return true;
                }
            }
        }
        _h5FullScreenJs.waitElementSizeChangedTimes = 3;
        return false;
    };

    /*数据结构,有两个成员:页面元素 + 层级, 用于排序*/
    _h5FullScreenJs.FixSizeElement = function(element) {
        this.element = element;
        this.depth = _h5FullScreenJs.getElementDepth(element);
    };

    _h5FullScreenJs.fixSizeElements = new Array();
    /*修复或矫正video及及其父元素的尺寸,比如腾讯站点自身js有bug导致从横屏时，以及从横屏返回竖屏时video的尺寸错误*/
    _h5FullScreenJs.fixVideoSize = function(isExit) {
        if (!_h5FullScreenJs.videoTag) {
            return false;
        }
        if (_h5FullScreenJs.videoIframe) {
            _h5FullScreenJs.noMinSize(document.body);
        }
        var fixing = true;
        if (!isExit) {
            var element = _h5FullScreenJs.videoTag;
            while (element) {
                /*fullscreenCtrl.info("fixVideoSize 0 " + _h5FullScreenJs.elementToString(element));*/
                _h5FullScreenJs.noMinSize(element);
                fixing &= _h5FullScreenJs.fixElementSize(element);
                element = element.parentElement;
            }
            _h5FullScreenJs.fixSizeElements.sort(function(a, b) {
                return a.depth - b.depth;
            });
        } else {
            var element = _h5FullScreenJs.videoTag;
            while (element) {
                _h5FullScreenJs.noMinSize(element);
                element = element.parentElement;
            }

            for (var i = 0; i < _h5FullScreenJs.fixSizeElements.length; i++) {
                var element = _h5FullScreenJs.fixSizeElements[i].element;
                /*fullscreenCtrl.info("fixVideoSize 1 " + _h5FullScreenJs.elementToString(element));*/
                fixing &= _h5FullScreenJs.fixElementSize(element);
            }
            _h5FullScreenJs.fixSizeElements = new Array();
        }
        return fixing;
    };

    /*获取页面元素的层级*/
    _h5FullScreenJs.getElementDepth = function(element) {
        var depth = 0;
        while (element) {
            depth += 1;
            element = element.parentElement;
        }
        return depth;
    };

    /*修复或矫正页面元素尺寸的内部方法*/
    _h5FullScreenJs.fixElementSize = function(element) {
        if (element && element.style && (element.style.width || element.style.height)) {
            var wv = 0;
            var hv = 0;
            var w = element.style.width;
            var h = element.style.height;
            if (w.indexOf("px") > 0) {
                wv = parseFloat(w);
            }
            if (h.indexOf("px") > 0) {
                hv = parseFloat(h);
            }
            /*fullscreenCtrl.info("fixElementSize * " + "w:" +  wv + ",h:" + hv + ",clientWidth:" + document.body.clientWidth);*/
            if (wv > 0) {
                if (wv < document.body.clientWidth * _h5FullScreenJs.deviation || wv > document.body.clientWidth / _h5FullScreenJs.deviation) {
                    element.style.width = document.body.clientWidth + "px";
                    fullscreenCtrl.error("fixElementSize 0 " + _h5FullScreenJs.elementToString(element) + ",fixWidth:" + w + " => " + element.style.width);
                    if (hv > 0) {
                        element.style.height = document.body.clientWidth * 9 / 16 + "px";
                        fullscreenCtrl.error("fixElementSize 1 " + _h5FullScreenJs.elementToString(element) + ",fixHeight:" + h + " => " + element.style.height);
                    }
                    _h5FullScreenJs.fixSizeElements.push(new _h5FullScreenJs.FixSizeElement(element));
                    return false;
                }
            } else if (hv > 0) {
                var desiredHeight = element.clientWidth * 9 / 16;
                /* 4:3 或者 16:9,允许百分之五的误差 */
                if (hv > element.clientWidth * 0.75 * _h5FullScreenJs.deviation || hv < desiredHeight * _h5FullScreenJs.deviation) {
                    var fixedHeight = desiredHeight + "px";
                    element.style.height = fixedHeight;
                    fullscreenCtrl.error("fixElementSize 2 " + _h5FullScreenJs.elementToString(element) + ",fixHeight:" + h + " => " + fixedHeight);
                    _h5FullScreenJs.fixSizeElements.push(new _h5FullScreenJs.FixSizeElement(element));
                    return false;
                }
            }
        }
        return true;
    };

    /*清除我们在js中添加的延迟操作*/
    _h5FullScreenJs.clearTimeouts = function() {
        clearTimeout(_h5FullScreenJs.hideTopTimeout);
        clearTimeout(_h5FullScreenJs.hideBottomTimeout);
        clearTimeout(_h5FullScreenJs.timeoutRequestFakeFullScreen);
        clearTimeout(_h5FullScreenJs.timeoutExitFakeFullScreen);
        clearTimeout(_h5FullScreenJs.timeoutPlayManually);
    };

    _h5FullScreenJs.deviceSdkInt = 0;
    _h5FullScreenJs.deviceRelease = "";
    _h5FullScreenJs.deviceBrand = "";
    _h5FullScreenJs.deviceModel = "";
    _h5FullScreenJs.getDeviceInfo = function() {
        if (_h5FullScreenJs.deviceSdkInt > 0) {
            return;
        }
        var deviceInfoStr = fullscreenCtrl.getDeviceInfo();
        try {
            var deviceInfo = JSON.parse(deviceInfoStr);
            fullscreenCtrl.info("deviceInfo:" + JSON.stringify(deviceInfo));
            var sdkInt = parseInt(deviceInfo["SDK_INT"]);
            if (!isNaN(sdkInt)) {
                _h5FullScreenJs.deviceSdkInt = sdkInt;
            }
            _h5FullScreenJs.deviceRelease = deviceInfo["RELEASE"];
            _h5FullScreenJs.deviceBrand = deviceInfo["BRAND"];
            _h5FullScreenJs.deviceModel = deviceInfo["MODEL"];
            fullscreenCtrl.info("deviceInfo sdkInt:" + _h5FullScreenJs.deviceSdkInt);
        } catch(e) {}
    };

    _h5FullScreenJs.delayAdaptDevice = function(delay) {
        switch (_h5FullScreenJs.deviceSdkInt) {
            /*4.0 - 4.1*/
        case 14:
        case 15:
        case 16:
            return delay * 2.5;
            /*4.2 - 4.3*/
        case 17:
        case 18:
            return delay * 2;
            /*4.4*/
        case 19:
        case 20:
            return delay * 1.5;
            /*5.0以上*/
        default:
            return delay;
        }
    };

    /*动态设置各种延迟时机,其中obj.all代表默认值*/
    _h5FullScreenJs.delayTime = {};
    _h5FullScreenJs.getDelayTime = function() {
        var host = location.host;
        var value = 1500;
        if (host.indexOf(".pptv") > 0) {
             value = 2000;
        }
        _h5FullScreenJs.delayTime.afterLandscape = value;
        _h5FullScreenJs.delayTime.afterPortrait = 500;
        return _h5FullScreenJs.delayTime;
    };

    /*在页面中查找video标签*/
    _h5FullScreenJs.detectVideos = function() {
        /*有些站点在页面加载过程中会出现假的video标签,如腾讯站点,因此每次都必须重新找,当和上次不同时覆盖*/
        var videoIframe = null;
        var videoTag = document.querySelector('video');
        if (!videoTag) {
            var iframes = document.getElementsByTagName('iframe');
            for (var i = 0; i < iframes.length; i++) {
                videoIframe = iframes[i];
                try {
                    /*cross site exception*/
                    videoTag = videoIframe.contentDocument.getElementsByTagName('video')[0];
                } catch(e) {}
                if (videoTag) {
                    break;
                }
            }
        }
        if (!videoTag) {
            fullscreenCtrl.info("videoTag is not found!");
            return 0;
        }
        if (_h5FullScreenJs.videoTag) {
            if (videoTag == _h5FullScreenJs.videoTag) {
                return 2;
            }
            fullscreenCtrl.error("videoTag has changed, last found videoTag is a fake one");
        }
        _h5FullScreenJs.videoTag = videoTag;
        _h5FullScreenJs.videoIframe = videoIframe;
        fullscreenCtrl.info("videoTag is found!" + _h5FullScreenJs.elementToString(videoTag));
        return 1;
    };

    _h5FullScreenJs.addCanPlayListener = function() {
        if (!_h5FullScreenJs.videoTag) {
            fullscreenCtrl.info("addCanPlayListener, videoTag is null");
            return;
        }
        if (_h5FullScreenJs.videoTag.canplay || _h5FullScreenJs.videoTag.currentTime > 0 || _h5FullScreenJs.videoTag.duration > 0) {
            fullscreenCtrl.info("addCanPlayListener, isAlready canPlay");
            _h5FullScreenJs.onCanPlay();
        } else {
            _h5FullScreenJs.removeCanPlayListener();
            _h5FullScreenJs.videoTag.addEventListener('canplay', _h5FullScreenJs.onCanPlay);
            _h5FullScreenJs.videoTag.addEventListener('timeupdate', _h5FullScreenJs.onCanPlay);
            _h5FullScreenJs.videoTag.addEventListener('durationchange', _h5FullScreenJs.onCanPlay);
            fullscreenCtrl.info("addCanPlayListener");
        }
    };

    _h5FullScreenJs.removeCanPlayListener = function() {
        if (!_h5FullScreenJs.videoTag) {
            fullscreenCtrl.info("removeCanPlayListener, videoTag is null");
            return;
        }
        _h5FullScreenJs.videoTag.removeEventListener('canplay', _h5FullScreenJs.onCanPlay);
        _h5FullScreenJs.videoTag.removeEventListener('timeupdate', _h5FullScreenJs.onCanPlay);
        _h5FullScreenJs.videoTag.removeEventListener('durationchange', _h5FullScreenJs.onCanPlay);
        fullscreenCtrl.info("removeCanPlayListener");
    };

    _h5FullScreenJs.timeoutAfterLandscape = 0;
    _h5FullScreenJs.enter = function() {
        clearTimeout(_h5FullScreenJs.timeoutAfterLandscape);
        var fullScreenMode = fullscreenCtrl.getFullScreenMode();
        fullscreenCtrl.info("enter, fullScreenMode:" + fullScreenMode);
        var delay = _h5FullScreenJs.delayAdaptDevice;
        switch (fullScreenMode) {
        case 2:
            var delayTime = _h5FullScreenJs.getDelayTime();
            fullscreenCtrl.setRequestedOrientationByJs(6);
            _h5FullScreenJs.timeoutAfterLandscape = _h5FullScreenJs.setTimeoutByJava('webkitRequestFakeFullScreen()', delay(delayTime.afterLandscape));
            break;

        case 3:
        case 4:
            fullscreenCtrl.callJsVideoCmd("webkitRequestFullScreen()", true);
            break;
        }
    };

    _h5FullScreenJs.timeoutAfterPortrait = 0;
    _h5FullScreenJs.exit = function() {
        clearTimeout(_h5FullScreenJs.timeoutAfterPortrait);
        var fullScreenMode = fullscreenCtrl.getFullScreenMode();
        fullscreenCtrl.info("exit, fullScreenMode:" + fullScreenMode);
        var delay = _h5FullScreenJs.delayAdaptDevice;
        switch (fullScreenMode) {
        case 2:
            var delayTime = _h5FullScreenJs.getDelayTime();
            fullscreenCtrl.setRequestedOrientationByJs(1);
            _h5FullScreenJs.timeoutAfterPortrait = _h5FullScreenJs.setTimeoutByJava('webkitExitFakeFullScreen()', delay(delayTime.afterPortrait));
            break;

        case 3:
        case 4:
            fullscreenCtrl.callJsVideoCmd("webkitExitFullScreen()", true);
            break;
        }
    };

    _h5FullScreenJs.onCanPlay = function() {
        fullscreenCtrl.info("onCanPlay");
        _h5FullScreenJs.clearTimeouts();
        _h5FullScreenJs.removeCanPlayListener();
        _h5FullScreenJs.enter();
    };

    _h5FullScreenJs.setJsData = function(key,value) {
        if (!fullscreenCtrl.setJsData) {
            return;
        }
        fullscreenCtrl.setJsData(key,value);
    };

    _h5FullScreenJs.getJsData = function(key) {
        if (!fullscreenCtrl.getJsData) {
            return null;
        }
        return fullscreenCtrl.getJsData(key);
    };

    _h5FullScreenJs.loadPageUrl = function(url) {
        fullscreenCtrl.info("loadPageUrl, url:" + url);
        _h5FullScreenJs.onPageChanged(url);
    };

    _h5FullScreenJs.isValidUrl = function(url) {
        if (!url || url.length == 0 || url == "about:blank") {
            return false;
        }
        return true;
    };

    _h5FullScreenJs.isRedirectUrl = function(url) {
        /*手机UA下www域名会跳转到m域名,因此www域名页面的加载只是一个中间过程,ipad UA除外*/
        if (url.startsWith("http://www.") || url.startsWith("https://www.")) {
            if (url.indexOf("www.1905.com") >= 0) {
                return false;
            }
            if (navigator.userAgent.indexOf("iPad") < 0) {
                /*非ipad ua会重定向到移动端网页*/
                return true;
            }
        }
        return false;
    };

    _h5FullScreenJs.formatTitle = function(title) {
        if (!title || typeof title != "string" || title.length == 0) {
            return "";
        }
        /*
        iqiyi 女管家第1集-电视剧-高清正版视频-爱奇艺/女管家第1集-电视剧-高清正版视频–爱奇艺
        sohu  女管家第1集/屌丝男士第3季第2集_屌丝男士第3季全集视频_搜狐视频
        youku 女管家 01
        pptv  女管家(第02集) - 聚力视频,一起玩出精彩/魔力女管家特别篇-我回来了(第02集) - 聚力视频,一起玩出精彩
        fun   女管家 第1集-电视剧-在线观看-高清下载-风行网
        letv  女管家01电视剧_手机乐视视频/女管家03
        mgtv  女管家 第1集 - 芒果TV
        */
        var fTitle = title.replace(" ","").replace("–","-");
        var seps = ["-", "_"];
        for (var i=0;i<seps.length;i++) {
            var sep = seps[i];
            var sepIndex = fTitle.indexOf(sep);
            if (sepIndex > 0) {
                /* 魔力女管家特别篇-我回来了(第02集) - 聚力视频,一起玩出精彩 */
                if (fTitle.indexOf('第',sepIndex) > 0 && fTitle.indexOf('集', sepIndex) > 0) {
                    continue;
                }
                fTitle = fTitle.substr(0,sepIndex);
            }
        }
        fullscreenCtrl.info("formatTitle:" + title + " => " + fTitle);
        return fTitle;
    };

    _h5FullScreenJs.isNewVideoPageTitle = function() {
        var title = _h5FullScreenJs.formatTitle(document.title);
        if (title == "") {
            fullscreenCtrl.error("isNewVideoPageTitle, title is invalid");
            return false;
        }
        var oldTitle = _h5FullScreenJs.getJsData("title");
        if (title == oldTitle) {
            return false;
        }
        if (oldTitle && oldTitle != "") {
            /* letv 标题存在包含关系, 如女管家01电视剧_手机乐视视频 和 女管家01 应该视为同一个视频*/
            if (oldTitle.indexOf(title) >= 0 ||
                title.indexOf(oldTitle) >= 0) {
                fullscreenCtrl.error("isNewVideoPageTitle, title contains another:" + title + " <=> " + oldTitle);
                return false;
            }
        }
        var host = _h5FullScreenJs.getJsData("host");
        if (host && host != "") {
            /* 用户在网页内可以点击其他视频,但是不会跨域,常见的情况下点击广告链接会导致跨域 */
            if (location.host != host) {
                fullscreenCtrl.error("isNewVideoPageTitle, cross domain:" + host + " => " + location.host);
                return false;
            }
        }

        fullscreenCtrl.info("isNewVideoPageTitle, newTitle:'" + title + "',oldTitle:'" + oldTitle + "'");
        _h5FullScreenJs.setJsData("title",title);
        _h5FullScreenJs.setJsData("host", location.host);
        return true;
    };

    _h5FullScreenJs.addPlaySuccessListener = function() {
        if (!_h5FullScreenJs.videoTag) {
            fullscreenCtrl.error("addPlaySuccessListener, videoTag is null");
            return;
        }
        _h5FullScreenJs.removePlaySuccessListener();
        fullscreenCtrl.info("addPlaySuccessListener");
        _h5FullScreenJs.videoTag.addEventListener("durationchange", _h5FullScreenJs.checkPlaySuccess);
    };

    _h5FullScreenJs.removePlaySuccessListener = function() {
        if (!_h5FullScreenJs.videoTag) {
            fullscreenCtrl.error("removePlaySuccessListener, videoTag is null");
            return;
        }
        fullscreenCtrl.info("removePlaySuccessListener");
        _h5FullScreenJs.videoTag.removeEventListener("durationchange", _h5FullScreenJs.checkPlaySuccess);
    };

    _h5FullScreenJs.checkPlaySuccess = function() {
        var durationData = _h5FullScreenJs.getDuration();
        fullscreenCtrl.info("checkPlaySuccess, durationData:" + durationData);
        var dataParts = durationData.split(",");
        if (dataParts.length != 2) {
            fullscreenCtrl.error("checkPlaySuccess, durationData is not in valid format");
            return;
        }
        var duration = dataParts[0];
        var isAd = dataParts[1];
        if (duration == 0) {
            fullscreenCtrl.info("checkPlaySuccess, duration is 0");
            return;
        }
        if (isAd == 1) {
            fullscreenCtrl.info("checkPlaySuccess, this is a Ad segment");
            _h5FullScreenJs.countPlayAdSuccess();
            return;
        }
        _h5FullScreenJs.removePlaySuccessListener();
        _h5FullScreenJs.countPlaySuccess();
    };

    /* 有可能切页面导致videoTag变更,有可能不会,跟系统版本和站点有关 */
    _h5FullScreenJs.onTitleChanged = function(mutationEvent) {
        if (_h5FullScreenJs.isNewVideoPageTitle()) {
            _h5FullScreenJs.countPlayTry();
        }
        if (fullscreenCtrl.getJsData("PlayTry") == "1") {
            if (!mutationEvent) {
                _h5FullScreenJs.checkPlaySuccess();
            }
            _h5FullScreenJs.addPlaySuccessListener();
        }
        _h5FullScreenJs.triggerPlay();
    };

    _h5FullScreenJs.triggerPlay = function() {
        fullscreenCtrl.info("triggerPlay");
        _h5FullScreenJs.selectDefinition();
        _h5FullScreenJs.addCanPlayListener();
        if (_h5FullScreenJs.isPlayManuallySite()) {
            _h5FullScreenJs.playManually(false);
        }
    };

    _h5FullScreenJs.timeoutPlayManually = 0;
    _h5FullScreenJs.playManually = function(isRetry) {
        fullscreenCtrl.info("playManually, isRetry:" + isRetry);
        clearTimeout(_h5FullScreenJs.timeoutPlayManually);
        if (!_h5FullScreenJs.getPlayBtn()) {
            /*通过video标签的play方法触发播放*/
            _h5FullScreenJs.play();
            return;
        }
        var playBtn = _h5FullScreenJs.playBtn;
        var style = getComputedStyle(playBtn);
        var isPlayBtnHidden = playBtn.hidden || (style && style.display == 'none');
        fullscreenCtrl.info("isPlayBtnHidden:" + isPlayBtnHidden + ",playBtn:" + _h5FullScreenJs.elementToString(playBtn));
        if (isPlayBtnHidden) {
            var retryCmd = "playManually(true)";
            var delay = _h5FullScreenJs.delayAdaptDevice;
            _h5FullScreenJs.timeoutPlayManually = _h5FullScreenJs.setTimeoutByJava(retryCmd, delay(500));
            return;
        }
        _h5FullScreenJs.play();
    };

    _h5FullScreenJs.newProgress = 0;
    _h5FullScreenJs.onProgressChanged = function(url, origUrl, newProgress) {
        fullscreenCtrl.info("onProgressChanged, newProgress:" + newProgress + ",url:" + url + ",origUrl:" + origUrl);
        if (newProgress == 0) {
            return;
        }

        if (!_h5FullScreenJs.isValidUrl(url) || !_h5FullScreenJs.isValidUrl(origUrl)) {
            fullscreenCtrl.error("onProgressChanged, url or origUrl is invalid");
            return;
        }

        if (_h5FullScreenJs.isRedirectUrl(url)) {
            fullscreenCtrl.info("onProgressChanged, url is a redirect url");
            return;
        }

        if (newProgress == _h5FullScreenJs.newProgress) {
            return;
        }

        _h5FullScreenJs.newProgress = newProgress;
        var detect = _h5FullScreenJs.detectVideos();
        if (detect == 1) {
            _h5FullScreenJs.onTitleChanged(null);
            /* 监听标题变化 */
            var title = document.querySelector('title');
            fullscreenCtrl.info("onProgressChanged, titleTag:" + _h5FullScreenJs.elementToString(title));
            if (title) {
                title.removeEventListener('DOMSubtreeModified',_h5FullScreenJs.onTitleChanged);
                title.addEventListener('DOMSubtreeModified',_h5FullScreenJs.onTitleChanged);
            }
        }
    };

    _h5FullScreenJs.onPageStarted = function(url, origUrl) {
        fullscreenCtrl.info("onPageStarted, url:" + url + ",origUrl:" + origUrl);
    };

    _h5FullScreenJs.onPageFinished = function(url, origUrl) {
        fullscreenCtrl.info("onPageFinished, url:" + url + ",origUrl:" + origUrl);
        _h5FullScreenJs.onProgressChanged(url, origUrl, 100);
    };

    _h5FullScreenJs.timeoutRequestFullScreen = 0;
    /*通过video标签的标准方法申请全屏*/
    _h5FullScreenJs.webkitRequestFullScreen = function() {
        fullscreenCtrl.info("webkitRequestFullScreen");
        if (_h5FullScreenJs.isFullScreen) {
            _h5FullScreenJs.play();
            fullscreenCtrl.info("webkitRequestFullScreen isFullScreen is true");
            return;
        }
        _h5FullScreenJs.doRequestFullScreen(false, false);
    };

    /*执行假全屏的内部方法*/
    _h5FullScreenJs.doRequestFullScreen = function(isOnOrientationChange, isRetry) {
        fullscreenCtrl.info("doRequestFullScreen, isOnOrientationChange:" + isOnOrientationChange + ",isRetry:" + isRetry);
        clearTimeout(_h5FullScreenJs.timeoutRequestFullScreen);
        var delay = _h5FullScreenJs.delayAdaptDevice;
        var retryCmd = "doRequestFullScreen(false,true)";
        if (!_h5FullScreenJs.play()) {
            fullscreenCtrl.error("doRequestFullScreen play failed");
            _h5FullScreenJs.timeoutRequestFakeFullScreen = _h5FullScreenJs.setTimeoutByJava(retryCmd, delay(1500));
            return;
        }
        var rect = _h5FullScreenJs.getVideoPos();
        if (rect.width <= 0 || rect.height <= 0) {
            fullscreenCtrl.error("doRequestFullScreen videoTag size is 0");
            _h5FullScreenJs.timeoutRequestFakeFullScreen = _h5FullScreenJs.setTimeoutByJava(retryCmd, delay(1500));
            return;
        }
        if (_h5FullScreenJs.videoTag.webkitRequestFullScreen) {
            if (fullscreenCtrl.getFullScreenMode() == 3) {
                _h5FullScreenJs.clickFullScreenBtn(true);
            } else {
                _h5FullScreenJs.videoTag.webkitRequestFullScreen();
            }
        } else {
            fullscreenCtrl.error("webkitRequestFullScreen videoTag.webkitRequestFullScreen is not supported");
        }
        if (_h5FullScreenJs.videoIframe && _h5FullScreenJs.videoIframe.webkitRequestFullScreen) {
            _h5FullScreenJs.videoIframe.webkitRequestFullScreen();
        }
    };

    /*通过video标签的标准方法申请退出全屏*/
    _h5FullScreenJs.webkitExitFullScreen = function() {
        fullscreenCtrl.info("webkitExitFullScreen");
        clearTimeout(_h5FullScreenJs.timeoutRequestFullScreen);
        if (!_h5FullScreenJs.videoTag) {
            fullscreenCtrl.error("webkitExitFullScreen videoTag is null");
            return;
        }
        if (!_h5FullScreenJs.isFullScreen) {
            fullscreenCtrl.info("webkitExitFullScreen isFullScreen is false");
            return;
        }
        if (_h5FullScreenJs.videoTag.webkitExitFullscreen) {
            if (fullscreenCtrl.getFullScreenMode() == 3) {
                _h5FullScreenJs.clickFullScreenBtn(false);
            } else {
                _h5FullScreenJs.videoTag.webkitExitFullscreen();
            }
        } else {
            fullscreenCtrl.error("webkitExitFullScreen videoTag.webkitExitFullscreen is not supported");
        }
        if (_h5FullScreenJs.videoIframe && _h5FullScreenJs.videoIframe.webkitExitFullscreen) {
            _h5FullScreenJs.videoIframe.webkitExitFullscreen();
        }
    };

    _h5FullScreenJs.timeoutRequestFakeFullScreen = 0;
    /*假全屏*/
    _h5FullScreenJs.webkitRequestFakeFullScreen = function() {
        fullscreenCtrl.info("webkitRequestFakeFullScreen");
        _h5FullScreenJs.clearTimeouts();
        _h5FullScreenJs.doRequestFakeFullScreen(false, false);
    };

    /*执行假全屏的内部方法*/
    _h5FullScreenJs.doRequestFakeFullScreen = function(isOnOrientationChange, isRetry) {
        fullscreenCtrl.info("doRequestFakeFullScreen, isOnOrientationChange:" + isOnOrientationChange + ",isRetry:" + isRetry);
        var delay = _h5FullScreenJs.delayAdaptDevice;
        var retryCmd = "doRequestFakeFullScreen(false,true)";
        document.removeEventListener('scroll', _h5FullScreenJs.onDocumentScroll);
        if (window.orientation == 0) {
            fullscreenCtrl.error("doRequestFakeFullScreen oriention is still portrait");
            _h5FullScreenJs.timeoutRequestFakeFullScreen = _h5FullScreenJs.setTimeoutByJava(retryCmd, delay(500));
            return;
        }
        if (!_h5FullScreenJs.play()) {
            fullscreenCtrl.error("doRequestFakeFullScreen play failed");
            _h5FullScreenJs.timeoutRequestFakeFullScreen = _h5FullScreenJs.setTimeoutByJava(retryCmd, delay(1500));
            return;
        }
        var rect = _h5FullScreenJs.getVideoPos();
        if (rect.width <= 0 || rect.height <= 0) {
            fullscreenCtrl.error("doRequestFakeFullScreen videoTag size is 0");
            _h5FullScreenJs.timeoutRequestFakeFullScreen = _h5FullScreenJs.setTimeoutByJava(retryCmd, delay(1500));
            return;
        }

        _h5FullScreenJs.hideTopElements(true);
        _h5FullScreenJs.hideBottomElements(true);

        if (!_h5FullScreenJs.fixVideoSize(false)) {
            fullscreenCtrl.info("doRequestFakeFullScreen videoTag size is fixing");
            _h5FullScreenJs.timeoutRequestFakeFullScreen = _h5FullScreenJs.setTimeoutByJava(retryCmd, delay(500));
            return;
        }

        var isVideoSizeUnchanged = _h5FullScreenJs.isElementSizeStillUnchangedAfterOrientationChanged(_h5FullScreenJs.videoTag);
        if (isVideoSizeUnchanged) {
            _h5FullScreenJs.timeoutRequestFakeFullScreen = _h5FullScreenJs.setTimeoutByJava(retryCmd, delay(1000));
            return;
        }

        /* 重新计算视频位置*/
        rect = _h5FullScreenJs.getVideoPos();
        var bodyRect = document.body.getBoundingClientRect();
        if (rect.width < bodyRect.width) {
            if (_h5FullScreenJs.zoomRatioByJava == 1) {
                var ratio = bodyRect.width / rect.width;
                if (ratio < 5) {
                    _h5FullScreenJs.zoomIn(ratio);
                }
                fullscreenCtrl.info("doRequestFakeFullScreen videoTag is zooming");
            }
            return;
        }

        _h5FullScreenJs.scrollToVideo();
    };

    _h5FullScreenJs.timeoutExitFakeFullScreen = 0;
    /*退出假全屏*/
    _h5FullScreenJs.webkitExitFakeFullScreen = function() {
        fullscreenCtrl.info("webkitExitFakeFullScreen");
        _h5FullScreenJs.clearTimeouts();
        _h5FullScreenJs.doExitFakeFullScreen(false, false);
    };

    /*退出假全屏的内部方法*/
    _h5FullScreenJs.doExitFakeFullScreen = function(isOnOrientationChange, isRetry) {
        fullscreenCtrl.info("doExitFakeFullScreen, isOnOrientationChange:" + isOnOrientationChange + ",isRetry:" + isRetry);
        var delay = _h5FullScreenJs.delayAdaptDevice;
        if (!_h5FullScreenJs.videoTag) {
            fullscreenCtrl.error("doExitFakeFullScreen videoTag is null");
            return;
        }
        if (window.orientation != 0) {
            fullscreenCtrl.error("doExitFakeFullScreen orientation is not portrait, do againt later");
            _h5FullScreenJs.timeoutExitFakeFullScreen = _h5FullScreenJs.setTimeoutByJs('doExitFakeFullScreen(false,true)', delay(500));
            return;
        }

        document.removeEventListener('scroll', _h5FullScreenJs.onDocumentScroll);
        _h5FullScreenJs.zoomOut();
        if (_h5FullScreenJs.elementsHideDelay >= 0) {
            _h5FullScreenJs.hideTopElements(false);
            _h5FullScreenJs.hideBottomElements(false);
        }

        var isVideoRelatedElementSizeUnchanged = _h5FullScreenJs.isElementSizeStillUnchangedAfterOrientationChanged(_h5FullScreenJs.videoTag);
        if (isVideoRelatedElementSizeUnchanged) {
            _h5FullScreenJs.timeoutExitFakeFullScreen = _h5FullScreenJs.setTimeoutByJs('doExitFakeFullScreen(false,true)', delay(500));
            return;
        }

        _h5FullScreenJs.fixVideoSize(true);

        document.body.scrollTop = 0;
        document.body.scrollLeft = 0;
    };

    /*
     _h5FullScreenJs.onOrientationChange = function() {
     if (window.orientation == 90 || window.orientation == -90) {
     _h5FullScreenJs.timeoutRequestFakeFullScreen =  _h5FullScreenJs.setTimeoutByJava('webkitRequestFakeFullScreen(true)',1000);
     } else {
     _h5FullScreenJs.timeoutExitFakeFullScreen = _h5FullScreenJs.setTimeoutByJava('webkitExitFakeFullScreen(true)',1000);
     }
     };

     window.addEventListener('orientationchange', _h5FullScreenJs.onOrientationChange);
     */

    _h5FullScreenJs.getDeviceInfo();
}